/* A Bison parser, made from cfg_file.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	K_OPTIONS	257
# define	K_DEFAULT	258
# define	K_PORT	259
# define	K_PERSIST	260
# define	K_TIMEOUT	261
# define	K_PASSWD	262
# define	K_PROG	263
# define	K_PPP	264
# define	K_SPEED	265
# define	K_IFCFG	266
# define	K_FWALL	267
# define	K_ROUTE	268
# define	K_DEVICE	269
# define	K_MULTI	270
# define	K_SRCADDR	271
# define	K_IFACE	272
# define	K_ADDR	273
# define	K_TYPE	274
# define	K_PROT	275
# define	K_COMPRESS	276
# define	K_ENCRYPT	277
# define	K_KALIVE	278
# define	K_STAT	279
# define	K_UP	280
# define	K_DOWN	281
# define	K_SYSLOG	282
# define	K_IPROUTE	283
# define	K_HOST	284
# define	K_ERROR	285
# define	WORD	286
# define	PATH	287
# define	STRING	288
# define	NUM	289
# define	DNUM	290

#line 1 "cfg_file.y"

/*  
    VTun - Virtual Tunnel over TCP/IP network.

    Copyright (C) 1998-2000  Maxim Krasnyansky <max_mk@yahoo.com>

    VTun has been derived from VPPP package by Maxim Krasnyansky. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 */

/*
 * cfg_file.y,v 1.1.1.2.2.12 2002/04/25 09:19:50 bergolth Exp
 */ 

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <syslog.h>

#include "vtun.h"
#include "lib.h"
#include "compat.h"

int lineno = 1;

struct vtun_host *parse_host;
extern struct vtun_host default_host;

llist  *parse_cmds;
struct vtun_cmd parse_cmd;

llist host_list;

int  cfg_error(const char *fmt, ...);
int  add_cmd(llist *cmds, char *prog, char *args, int flags);
void *cp_cmd(void *d, void *u);
int  free_cmd(void *d, void *u);

void copy_addr(struct vtun_host *to, struct vtun_host *from);
int  free_host(void *d, void *u);
void free_addr(struct vtun_host *h);
void free_host_list(void);

int  parse_syslog(char *facility);

int yyparse(void);
int yylex(void);	
int yyerror(char *s); 

#define YYERROR_VERBOSE 1


#line 67 "cfg_file.y"
#ifndef YYSTYPE
typedef union {
   char *str;
   int  num;
   struct { int num1; int num2; } dnum;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		128
#define	YYFLAG		-32768
#define	YYNTBASE	40

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 290 ? yytranslate[x] : 62)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      37,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    38,     2,    39,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     4,     6,    11,    12,    18,    19,    25,
      27,    29,    32,    34,    37,    40,    43,    46,    49,    52,
      55,    58,    61,    63,    65,    67,    69,    71,    74,    76,
      79,    82,    85,    88,    91,    94,    95,    99,   102,   103,
     107,   110,   113,   116,   119,   124,   125,   131,   132,   138,
     140,   142,   144,   146,   148,   150,   152,   153,   155,   158,
     161,   164,   167,   170,   172,   173,   175,   178,   180,   181,
     185,   188,   191,   194,   197,   200,   202,   204,   207,   209,
     211
};
static const short yyrhs[] =
{
      -1,    40,    41,     0,    37,     0,     3,    38,    44,    39,
       0,     0,     4,    42,    38,    47,    39,     0,     0,    30,
      43,    38,    47,    39,     0,    31,     0,    45,     0,    44,
      45,     0,    37,     0,     5,    35,     0,    20,    35,     0,
       7,    35,     0,    10,    33,     0,    12,    33,     0,    14,
      33,     0,    13,    33,     0,    29,    33,     0,    28,    46,
       0,    31,     0,    35,     0,    32,     0,    31,     0,    48,
       0,    47,    48,     0,    37,     0,     8,    32,     0,    15,
      32,     0,    16,    35,     0,     7,    35,     0,    11,    35,
       0,    11,    36,     0,     0,    22,    49,    53,     0,    23,
      35,     0,     0,    24,    50,    54,     0,    25,    35,     0,
       6,    35,     0,    20,    35,     0,    21,    35,     0,    17,
      38,    55,    39,     0,     0,    26,    51,    38,    57,    39,
       0,     0,    27,    52,    38,    57,    39,     0,    31,     0,
      35,     0,    36,     0,    31,     0,    35,     0,    36,     0,
      31,     0,     0,    56,     0,    55,    56,     0,    19,    32,
       0,    18,    32,     0,    18,    34,     0,     5,    35,     0,
      31,     0,     0,    58,     0,    57,    58,     0,    37,     0,
       0,     9,    59,    60,     0,    10,    34,     0,    12,    34,
       0,    14,    34,     0,    13,    34,     0,    29,    34,     0,
      31,     0,    61,     0,    60,    61,     0,    33,     0,    34,
       0,    35,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,    86,    87,    90,    91,    93,    93,    98,    98,   131,
     137,   139,   143,   144,   149,   154,   159,   164,   169,   174,
     179,   184,   186,   192,   197,   204,   210,   212,   217,   218,
     223,   228,   232,   236,   244,   253,   253,   258,   265,   265,
     270,   277,   284,   289,   294,   296,   296,   301,   301,   306,
     312,   320,   325,   331,   337,   345,   351,   352,   353,   356,
     363,   369,   375,   379,   385,   386,   387,   390,   391,   391,
     399,   404,   409,   414,   419,   424,   430,   432,   435,   440,
     444
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "K_OPTIONS", "K_DEFAULT", "K_PORT", 
  "K_PERSIST", "K_TIMEOUT", "K_PASSWD", "K_PROG", "K_PPP", "K_SPEED", 
  "K_IFCFG", "K_FWALL", "K_ROUTE", "K_DEVICE", "K_MULTI", "K_SRCADDR", 
  "K_IFACE", "K_ADDR", "K_TYPE", "K_PROT", "K_COMPRESS", "K_ENCRYPT", 
  "K_KALIVE", "K_STAT", "K_UP", "K_DOWN", "K_SYSLOG", "K_IPROUTE", 
  "K_HOST", "K_ERROR", "WORD", "PATH", "STRING", "NUM", "DNUM", "'\\n'", 
  "'{'", "'}'", "config", "statement", "@1", "@2", "options", "option", 
  "syslog_opt", "host_options", "host_option", "@3", "@4", "@5", "@6", 
  "compress", "keepalive", "srcaddr_options", "srcaddr_option", 
  "command_options", "command_option", "@7", "prog_options", 
  "prog_option", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    40,    40,    41,    41,    42,    41,    43,    41,    41,
      44,    44,    45,    45,    45,    45,    45,    45,    45,    45,
      45,    45,    45,    46,    46,    46,    47,    47,    48,    48,
      48,    48,    48,    48,    48,    49,    48,    48,    50,    48,
      48,    48,    48,    48,    48,    51,    48,    52,    48,    48,
      53,    53,    53,    54,    54,    54,    55,    55,    55,    56,
      56,    56,    56,    56,    57,    57,    57,    58,    59,    58,
      58,    58,    58,    58,    58,    58,    60,    60,    61,    61,
      61
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     2,     1,     4,     0,     5,     0,     5,     1,
       1,     2,     1,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     1,     1,     1,     1,     1,     2,     1,     2,
       2,     2,     2,     2,     2,     0,     3,     2,     0,     3,
       2,     2,     2,     2,     4,     0,     5,     0,     5,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     2,     2,
       2,     2,     2,     1,     0,     1,     2,     1,     0,     3,
       2,     2,     2,     2,     2,     1,     1,     2,     1,     1,
       1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       1,     0,     0,     5,     7,     9,     3,     2,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      22,    12,     0,    10,     0,     0,    13,    15,    16,    17,
      19,    18,    14,    25,    24,    23,    21,    20,     4,    11,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    35,
       0,    38,     0,    45,    47,    49,    28,     0,    26,     0,
      41,    32,    29,    33,    34,    30,    31,    56,    42,    43,
       0,    37,     0,    40,     0,     0,     6,    27,     8,     0,
       0,     0,    63,     0,    57,    52,    50,    51,    36,    55,
      53,    54,    39,    64,    64,    62,    60,    61,    59,    44,
      58,    68,     0,     0,     0,     0,     0,    75,    67,     0,
      65,     0,     0,    70,    71,    73,    72,    74,    46,    66,
      48,    78,    79,    80,    69,    76,    77,     0,     0
};

static const short yydefgoto[] =
{
       1,     7,     9,    10,    22,    23,    36,    57,    58,    70,
      72,    74,    75,    88,    92,    83,    84,   109,   110,   112,
     124,   125
};

static const short yypact[] =
{
  -32768,     0,   -36,-32768,-32768,-32768,-32768,-32768,    93,   -31,
     -28,   -22,   -12,     6,    34,    37,    41,     1,    16,    45,
  -32768,-32768,     4,-32768,   112,   112,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
       5,    44,    51,    21,    52,    58,    56,    64,    66,-32768,
      73,-32768,    74,-32768,-32768,-32768,-32768,    38,-32768,    65,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,     7,-32768,-32768,
     -30,-32768,   -16,-32768,    72,    76,-32768,-32768,-32768,    77,
      18,    79,-32768,     3,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,   172,   172,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,    81,    82,    83,    91,    92,-32768,-32768,   132,
  -32768,   141,    -6,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,    -6,-32768,-32768,   131,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,-32768,-32768,-32768,   118,-32768,   122,     9,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,    69,    54,   -14,-32768,
  -32768,    32
};


#define	YYLAST		209


static const short yytable[] =
{
     127,    85,     8,     2,     3,    86,    87,    24,    79,    11,
      25,    12,    79,    26,    13,    89,    14,    15,    16,    90,
      91,    80,    81,    27,    17,    80,    81,   121,   122,   123,
       4,     5,    18,    19,    82,    20,    32,     6,    82,    28,
      60,    21,    99,    38,    40,    41,    42,    33,    34,    43,
      96,    35,    97,    44,    45,    46,    63,    64,    47,    48,
      49,    50,    51,    52,    53,    54,    77,    29,    77,    55,
      30,    40,    41,    42,    31,    56,    43,    76,    37,    61,
      44,    45,    46,    62,    65,    47,    48,    49,    50,    51,
      52,    53,    54,    66,    67,   119,    55,   119,    11,    68,
      12,    69,    56,    13,    78,    14,    15,    16,    71,    73,
      93,    98,    95,    17,    94,   113,   114,   115,    40,    41,
      42,    18,    19,    43,    20,   116,   117,    44,    45,    46,
      21,   128,    47,    48,    49,    50,    51,    52,    53,    54,
      39,   101,   102,    55,   103,   104,   105,    59,   111,    56,
     101,   102,   100,   103,   104,   105,   126,     0,     0,     0,
       0,   106,     0,   107,     0,     0,     0,     0,     0,   108,
     106,   118,   107,     0,     0,     0,     0,     0,   108,     0,
     120,   101,   102,     0,   103,   104,   105,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   106,     0,   107,     0,     0,     0,     0,     0,   108
};

static const short yycheck[] =
{
       0,    31,    38,     3,     4,    35,    36,    38,     5,     5,
      38,     7,     5,    35,    10,    31,    12,    13,    14,    35,
      36,    18,    19,    35,    20,    18,    19,    33,    34,    35,
      30,    31,    28,    29,    31,    31,    35,    37,    31,    33,
      35,    37,    39,    39,     6,     7,     8,    31,    32,    11,
      32,    35,    34,    15,    16,    17,    35,    36,    20,    21,
      22,    23,    24,    25,    26,    27,    57,    33,    59,    31,
      33,     6,     7,     8,    33,    37,    11,    39,    33,    35,
      15,    16,    17,    32,    32,    20,    21,    22,    23,    24,
      25,    26,    27,    35,    38,   109,    31,   111,     5,    35,
       7,    35,    37,    10,    39,    12,    13,    14,    35,    35,
      38,    32,    35,    20,    38,    34,    34,    34,     6,     7,
       8,    28,    29,    11,    31,    34,    34,    15,    16,    17,
      37,     0,    20,    21,    22,    23,    24,    25,    26,    27,
      22,     9,    10,    31,    12,    13,    14,    25,    94,    37,
       9,    10,    83,    12,    13,    14,   124,    -1,    -1,    -1,
      -1,    29,    -1,    31,    -1,    -1,    -1,    -1,    -1,    37,
      29,    39,    31,    -1,    -1,    -1,    -1,    -1,    37,    -1,
      39,     9,    10,    -1,    12,    13,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    29,    -1,    31,    -1,    -1,    -1,    -1,    -1,    37
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 5:
#line 93 "cfg_file.y"
{ 
		  parse_host = &default_host; 
                }
    break;
case 7:
#line 98 "cfg_file.y"
{ 
		  if( !(parse_host = malloc(sizeof(struct vtun_host))) ){
		     yyerror("No memory for the host");
		     YYABORT;
		  }

		  /* Fill new host struct with default values.
		   * MUST dup strings to be able to reread config.
		   */
	  	  memcpy(parse_host, &default_host, sizeof(struct vtun_host));
		  parse_host->host = strdup(yyvsp[0].str);
		  parse_host->passwd = NULL;

		  /* Copy local address */
		  copy_addr(parse_host, &default_host);

		  llist_copy(&default_host.up,&parse_host->up,cp_cmd,NULL);
		  llist_copy(&default_host.down,&parse_host->down,cp_cmd,NULL);

		}
    break;
case 8:
#line 119 "cfg_file.y"
{
		  /* Check if session definition is complete */ 
		  if (!parse_host->passwd) {
		  	cfg_error("Ignored incomplete session definition '%s'", parse_host->host);
			free_host(parse_host, NULL);			
			free(parse_host);
		  } else {
		  	/* Add host to the list */
		  	llist_add(&host_list, (void *)parse_host);
		  }
		}
    break;
case 9:
#line 131 "cfg_file.y"
{
		  cfg_error("Invalid clause '%s'",yyvsp[0].str);
		  YYABORT;
		}
    break;
case 13:
#line 144 "cfg_file.y"
{ 
			  if(vtun.svr_port == -1)
			     vtun.svr_port = yyvsp[0].num;
			}
    break;
case 14:
#line 149 "cfg_file.y"
{ 
			  if(vtun.svr_type == -1)
			     vtun.svr_type = yyvsp[0].num;
			}
    break;
case 15:
#line 154 "cfg_file.y"
{  
			  if(vtun.timeout == -1)
			     vtun.timeout = yyvsp[0].num; 	
			}
    break;
case 16:
#line 159 "cfg_file.y"
{
			  free(vtun.ppp);
			  vtun.ppp = strdup(yyvsp[0].str);
			}
    break;
case 17:
#line 164 "cfg_file.y"
{
			  free(vtun.ifcfg);
			  vtun.ifcfg = strdup(yyvsp[0].str);
			}
    break;
case 18:
#line 169 "cfg_file.y"
{   
			  free(vtun.route);  
			  vtun.route = strdup(yyvsp[0].str); 	
			}
    break;
case 19:
#line 174 "cfg_file.y"
{   
			  free(vtun.fwall);  
			  vtun.fwall = strdup(yyvsp[0].str); 	
			}
    break;
case 20:
#line 179 "cfg_file.y"
{   
			  free(vtun.iproute);  
			  vtun.iproute = strdup(yyvsp[0].str); 	
			}
    break;
case 22:
#line 186 "cfg_file.y"
{
			  cfg_error("Unknown option '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;
case 23:
#line 193 "cfg_file.y"
{
                          vtun.syslog = yyvsp[0].num;
  			}
    break;
case 24:
#line 197 "cfg_file.y"
{
                          if (parse_syslog(yyvsp[0].str)) {
                            cfg_error("Unknown syslog facility '%s'", yyvsp[0].str);
                            YYABORT;
                          }
                        }
    break;
case 25:
#line 204 "cfg_file.y"
{
   			  cfg_error("Unknown syslog option '%s'",yyvsp[0].str);
  			  YYABORT;
			}
    break;
case 29:
#line 218 "cfg_file.y"
{
			  free(parse_host->passwd);
			  parse_host->passwd = strdup(yyvsp[0].str);
			}
    break;
case 30:
#line 223 "cfg_file.y"
{
			  free(parse_host->dev);
			  parse_host->dev = strdup(yyvsp[0].str);
			}
    break;
case 31:
#line 228 "cfg_file.y"
{ 
			  parse_host->multi = yyvsp[0].num;
			}
    break;
case 32:
#line 232 "cfg_file.y"
{ 
			  parse_host->timeout = yyvsp[0].num;
			}
    break;
case 33:
#line 236 "cfg_file.y"
{ 
			  if( yyvsp[0].num ){ 
			     parse_host->spd_in = parse_host->spd_out = yyvsp[0].num;
			     parse_host->flags |= VTUN_SHAPE;
			  } else 
			     parse_host->flags &= ~VTUN_SHAPE;
			}
    break;
case 34:
#line 244 "cfg_file.y"
{ 
			  if( yylval.dnum.num1 || yylval.dnum.num2 ){ 
			     parse_host->spd_out = yylval.dnum.num1;
		             parse_host->spd_in = yylval.dnum.num2; 	
			     parse_host->flags |= VTUN_SHAPE;
			  } else 
			     parse_host->flags &= ~VTUN_SHAPE;
			}
    break;
case 35:
#line 253 "cfg_file.y"
{
			  parse_host->flags &= ~(VTUN_ZLIB | VTUN_LZO); 
			}
    break;
case 37:
#line 258 "cfg_file.y"
{  
			  if( yyvsp[0].num )
			     parse_host->flags |= VTUN_ENCRYPT;
			  else
			     parse_host->flags &= ~VTUN_ENCRYPT;
			}
    break;
case 38:
#line 265 "cfg_file.y"
{
			  parse_host->flags &= ~VTUN_KEEP_ALIVE; 
			}
    break;
case 40:
#line 270 "cfg_file.y"
{
			  if( yyvsp[0].num )
			     parse_host->flags |= VTUN_STAT;
			  else
			     parse_host->flags &= ~VTUN_STAT;
			}
    break;
case 41:
#line 277 "cfg_file.y"
{ 
	      		  parse_host->persist = yyvsp[0].num;

			  if(vtun.persist == -1) 
			     vtun.persist = yyvsp[0].num; 	
			}
    break;
case 42:
#line 284 "cfg_file.y"
{  
			  parse_host->flags &= ~VTUN_TYPE_MASK;
			  parse_host->flags |= yyvsp[0].num;
			}
    break;
case 43:
#line 289 "cfg_file.y"
{  
			  parse_host->flags &= ~VTUN_PROT_MASK;
			  parse_host->flags |= yyvsp[0].num;
			}
    break;
case 45:
#line 296 "cfg_file.y"
{ 
			  parse_cmds = &parse_host->up; 
   			  llist_free(parse_cmds, free_cmd, NULL);   
			}
    break;
case 47:
#line 301 "cfg_file.y"
{ 
			  parse_cmds = &parse_host->down; 
   			  llist_free(parse_cmds, free_cmd, NULL);   
			}
    break;
case 49:
#line 306 "cfg_file.y"
{
			  cfg_error("Unknown option '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;
case 50:
#line 313 "cfg_file.y"
{ 
			  if( yyvsp[0].num ){  
      			     parse_host->flags |= VTUN_ZLIB; 
			     parse_host->zlevel = yyvsp[0].num;
			  }
			}
    break;
case 51:
#line 320 "cfg_file.y"
{
			  parse_host->flags |= yylval.dnum.num1;
		          parse_host->zlevel = yylval.dnum.num2;
  			}
    break;
case 52:
#line 325 "cfg_file.y"
{
			  cfg_error("Unknown compression '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;
case 53:
#line 332 "cfg_file.y"
{ 
			  if( yyvsp[0].num )
			     parse_host->flags |= VTUN_KEEP_ALIVE;
			}
    break;
case 54:
#line 337 "cfg_file.y"
{
			  if( yylval.dnum.num1 ){
			     parse_host->flags |= VTUN_KEEP_ALIVE;
			     parse_host->ka_interval = yylval.dnum.num1;
		             parse_host->ka_failure  = yylval.dnum.num2;
			  }
  			}
    break;
case 55:
#line 345 "cfg_file.y"
{
			  cfg_error("Unknown keepalive option '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;
case 59:
#line 357 "cfg_file.y"
{
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup(yyvsp[0].str);
			  parse_host->src_addr.type = VTUN_ADDR_NAME;
			}
    break;
case 60:
#line 363 "cfg_file.y"
{
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup(yyvsp[0].str);
			  parse_host->src_addr.type = VTUN_ADDR_IFACE;
			}
    break;
case 61:
#line 369 "cfg_file.y"
{
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup(yyvsp[0].str);
			  parse_host->src_addr.type = VTUN_ADDR_IFACE;
			}
    break;
case 62:
#line 375 "cfg_file.y"
{
			  parse_host->src_addr.port = yyvsp[0].num;
			}
    break;
case 63:
#line 379 "cfg_file.y"
{
			  cfg_error("Unknown option '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;
case 68:
#line 391 "cfg_file.y"
{
			  memset(&parse_cmd, 0, sizeof(struct vtun_cmd));
			}
    break;
case 69:
#line 394 "cfg_file.y"
{
			  add_cmd(parse_cmds, parse_cmd.prog, 
				  parse_cmd.args, parse_cmd.flags);
			}
    break;
case 70:
#line 399 "cfg_file.y"
{   
			  add_cmd(parse_cmds, strdup(vtun.ppp), strdup(yyvsp[0].str), 
					VTUN_CMD_DELAY);
			}
    break;
case 71:
#line 404 "cfg_file.y"
{   
			  add_cmd(parse_cmds, strdup(vtun.ifcfg),strdup(yyvsp[0].str),
					VTUN_CMD_WAIT);
			}
    break;
case 72:
#line 409 "cfg_file.y"
{   
			  add_cmd(parse_cmds, strdup(vtun.route),strdup(yyvsp[0].str),
					VTUN_CMD_WAIT);
			}
    break;
case 73:
#line 414 "cfg_file.y"
{   
			  add_cmd(parse_cmds, strdup(vtun.fwall),strdup(yyvsp[0].str),
					VTUN_CMD_WAIT);
			}
    break;
case 74:
#line 419 "cfg_file.y"
{   
			  add_cmd(parse_cmds, strdup(vtun.iproute),strdup(yyvsp[0].str),
					VTUN_CMD_WAIT);
			}
    break;
case 75:
#line 424 "cfg_file.y"
{
			  cfg_error("Unknown cmd '%s'",yyvsp[0].str);
			  YYABORT;
			}
    break;
case 78:
#line 436 "cfg_file.y"
{
			  parse_cmd.prog = strdup(yyvsp[0].str);
			}
    break;
case 79:
#line 440 "cfg_file.y"
{
			  parse_cmd.args = strdup(yyvsp[0].str);
			}
    break;
case 80:
#line 444 "cfg_file.y"
{
			  parse_cmd.flags = yyvsp[0].num;
			}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 448 "cfg_file.y"


int yyerror(char *s) 
{
   vtun_syslog(LOG_ERR, "%s line %d\n", s, lineno);
   return 0;
}

int cfg_error(const char *fmt, ...)
{
   char buf[255];
   va_list ap;

   /* print the argument string */
   va_start(ap, fmt);
   vsnprintf(buf,sizeof(buf),fmt,ap);
   va_end(ap);

   yyerror(buf);
   return 0;
}

int add_cmd(llist *cmds, char *prog, char *args, int flags)
{
   struct vtun_cmd *cmd;
   if( !(cmd = malloc(sizeof(struct vtun_cmd))) ){
      yyerror("No memory for the command");
      return -1;
   }
   memset(cmd, 0, sizeof(struct vtun_cmd)); 		   			

   cmd->prog = prog;
   cmd->args = args;
   cmd->flags = flags;
   llist_add(cmds, cmd);

   return 0;
}		

void *cp_cmd(void *d, void *u)
{
   struct vtun_cmd *cmd = d, *cmd_copy; 

   if( !(cmd_copy = malloc(sizeof(struct vtun_cmd))) ){
      yyerror("No memory to copy the command");
      return NULL;
   }
 
   cmd_copy->prog = strdup(cmd->prog);
   cmd_copy->args = strdup(cmd->args);
   cmd_copy->flags = cmd->flags;
   return cmd_copy;
}

int free_cmd(void *d, void *u)
{
   struct vtun_cmd *cmd = d; 
   free(cmd->prog);
   free(cmd->args);
   free(cmd);
   return 0;
}

void copy_addr(struct vtun_host *to, struct vtun_host *from)
{  
   if( from->src_addr.type ){
      to->src_addr.type = from->src_addr.type;
      to->src_addr.name = strdup(from->src_addr.name);
   }
   to->src_addr.port = from->src_addr.port;
}

void free_addr(struct vtun_host *h)
{  
   if( h->src_addr.type ){
      h->src_addr.type = 0;
      free(h->src_addr.name);
   }
}

int free_host(void *d, void *u)
{
   struct vtun_host *h = d;

   if (u && !strcmp(h->host, u))
      return 1;

   free(h->host);   
   free(h->passwd);   
   
   llist_free(&h->up, free_cmd, NULL);   
   llist_free(&h->down, free_cmd, NULL);

   free_addr(h);
 
   return 0;   
}

/* Find host in the hosts list.
 * NOTE: This function can be called only once since it deallocates hosts list.
 */ 
inline struct vtun_host* find_host(char *host)
{
   return (struct vtun_host *)llist_free(&host_list, free_host, host);
}

inline void free_host_list(void)
{
   llist_free(&host_list, free_host, NULL);
}

static struct {
   char *c_name;
   int  c_val;
} syslog_names[] = {
    { "auth",   LOG_AUTH },
    { "cron",   LOG_CRON },
    { "daemon", LOG_DAEMON },
    { "kern",   LOG_KERN },
    { "lpr",    LOG_LPR },
    { "mail",   LOG_MAIL },
    { "news",   LOG_NEWS },
    { "syslog", LOG_SYSLOG },
    { "user",   LOG_USER },
    { "uucp",   LOG_UUCP },
    { "local0", LOG_LOCAL0 },
    { "local1", LOG_LOCAL1 },
    { "local2", LOG_LOCAL2 },
    { "local3", LOG_LOCAL3 },
    { "local4", LOG_LOCAL4 },
    { "local5", LOG_LOCAL5 },
    { "local6", LOG_LOCAL6 },
    { "local7", LOG_LOCAL7 },
    { NULL, -1 }
};

int parse_syslog(char *facility)
{
   int i;

   for (i=0; syslog_names[i].c_name;i++) {
      if (!strcmp(syslog_names[i].c_name, facility)) {
         vtun.syslog = syslog_names[i].c_val;
         return(0);
      }
   }
}

/* 
 * Read config file. 
 */ 
int read_config(char *file) 
{
   static int cfg_loaded = 0;
   extern FILE *yyin;

   if( cfg_loaded ){
      free_host_list();
      vtun_syslog(LOG_INFO,"Reloading configuration file");
   }	 
   cfg_loaded = 1;

   llist_init(&host_list);

   if( !(yyin = fopen(file,"r")) ){
      vtun_syslog(LOG_ERR,"Can not open %s", file);
      return -1;      
   }

   yyparse();

   free_host(&default_host, NULL);

   fclose(yyin);
  
   return !llist_empty(&host_list);     
}
